diff --git a/web/pgadmin/browser/server_groups/servers/roles/__init__.py b/web/pgadmin/browser/server_groups/servers/roles/__init__.py
index dbf0d71..bfa424a 100644
--- a/web/pgadmin/browser/server_groups/servers/roles/__init__.py
+++ b/web/pgadmin/browser/server_groups/servers/roles/__init__.py
@@ -6,7 +6,6 @@
 # This software is released under the PostgreSQL Licence
 #
 ##########################################################################
-import datetime
 import re
 from functools import wraps
 
@@ -14,6 +13,7 @@ import pgadmin.browser.server_groups as sg
 import simplejson as json
 from flask import render_template, request, jsonify, current_app
 from flask_babel import gettext as _
+import dateutil.parser as dateutil_parser
 from pgadmin.browser.collection import CollectionNodeModule
 from pgadmin.browser.utils import PGChildNodeView
 from pgadmin.utils.ajax import make_json_response, \
@@ -142,11 +142,10 @@ class RoleView(PGChildNodeView):
                     if data[u'rolvaliduntil'] is not None and \
                                     data[u'rolvaliduntil'] != '' and \
                                     len(data[u'rolvaliduntil']) > 0:
-                        date = datetime.datetime.strptime(
-                            data[u'rolvaliduntil'], '%m/%d/%Y'
-                        )
-                        data[u'rolvaliduntil'] = date.strftime("%Y-%m-%d")
-                except Exception as e:
+                        data[u'rolvaliduntil'] = dateutil_parser.parse(
+                            data[u'rolvaliduntil']
+                        ).isoformat()
+                except Exception:
                     return precondition_required(
                         _("Date format is invalid.")
                     )
@@ -640,8 +639,6 @@ rolmembership:{
                     'admin': True if role.group(1) == '1' else False
                 })
             row['rolmembership'] = res
-            if row['rolvaliduntil'] is not None:
-                row['rolvaliduntil'] = row['rolvaliduntil'].split(' ')[0]
             if 'seclabels' in row and row['seclabels'] is not None:
                 res = []
                 for sec in row['seclabels']:
diff --git a/web/pgadmin/browser/static/js/node.ui.js b/web/pgadmin/browser/static/js/node.ui.js
index 90c9ada..695e413 100644
--- a/web/pgadmin/browser/static/js/node.ui.js
+++ b/web/pgadmin/browser/static/js/node.ui.js
@@ -1,10 +1,82 @@
-define(
-    ['jquery', 'underscore', 'pgadmin', 'backbone', 'backform', 'alertify', 'pgadmin.browser.node'],
+define([
+  'jquery', 'underscore', 'pgadmin', 'backbone', 'backform', 'alertify',
+  'pgadmin.browser.node', 'pgadmin.browser.messages'
+],
 function($, _, pgAdmin, Backbone, Backform, Alertify, Node) {
 
   var pgBrowser = pgAdmin.Browser;
 
   /*
+   * Define the selectAll adapter for select2.
+   *
+   * Reference:
+   * https://github.com/select2/select2/issues/195#issuecomment-240130634
+   */
+  $.fn.select2.amd.define('select2/selectAllAdapter', [
+    'select2/utils',
+    'select2/dropdown',
+    'select2/dropdown/attachBody'
+  ], function (Utils, Dropdown, AttachBody) {
+
+    function SelectAll() { }
+    SelectAll.prototype.render = function (decorated) {
+      var self = this,
+        $rendered = decorated.call(this),
+        $selectAll = $([
+          '<button class="btn btn-xs btn-default" type="button"',
+          ' style="width: 49%;margin: 0 0.5%;">',
+          '<i class="fa fa-check-square-o"></i>',
+          '<span style="padding: 0px 5px;">',
+          pgAdmin.Browser.messages['SELECT_ALL'],
+          '</span></button>'
+        ].join('')),
+        $unselectAll = $([
+          '<button class="btn btn-xs btn-default" type="button"',
+          ' style="width: 49%;margin: 0 0.5%;">',
+          '<i class="fa fa-square-o"></i><span style="padding: 0px 5px;">',
+          pgAdmin.Browser.messages['UNSELECT_ALL'],
+          '</span></button>'
+        ].join('')),
+        $btnContainer = $(
+          '<div style="padding: 3px 0px; background-color: #2C76B4; margin-bottom: 3px;">'
+        ).append($selectAll).append($unselectAll);
+
+      if (!this.$element.prop("multiple")) {
+        // this isn't a multi-select -> don't add the buttons!
+        return $rendered;
+      }
+      $rendered.find('.select2-dropdown').prepend($btnContainer);
+      $selectAll.on('click', function (e) {
+        var $results = $rendered.find('.select2-results__option[aria-selected=false]');
+        $results.each(function () {
+          self.trigger('select', {
+            data: $(this).data('data')
+          });
+        });
+        self.trigger('close');
+      });
+      $unselectAll.on('click', function (e) {
+        var $results = $rendered.find('.select2-results__option[aria-selected=true]');
+        $results.each(function () {
+          self.trigger('unselect', {
+            data: $(this).data('data')
+          });
+        });
+        self.trigger('close');
+      });
+      return $rendered;
+    };
+
+    return Utils.Decorate(
+      Utils.Decorate(
+        Dropdown,
+        AttachBody
+      ),
+      SelectAll
+    );
+  });
+
+  /*
    * NodeAjaxOptionsControl
    *   This control will fetch the options required to render the select
    *   control, from the url specific to the pgAdmin.Browser node object.
diff --git a/web/pgadmin/static/js/backform.pgadmin.js b/web/pgadmin/static/js/backform.pgadmin.js
index 6396094..aa63d3e 100644
--- a/web/pgadmin/static/js/backform.pgadmin.js
+++ b/web/pgadmin/static/js/backform.pgadmin.js
@@ -61,6 +61,7 @@
     'text': ['uneditable-input', 'input', 'string'],
     'numeric': ['uneditable-input', 'numeric', 'numeric'],
     'date': 'datepicker',
+    'datetime': 'datetimepicker',
     'boolean': 'boolean',
     'options': ['readonly-option', 'select', Backgrid.Extension.PGSelectCell],
     'multiline': ['textarea', 'textarea', 'string'],
@@ -1146,7 +1147,7 @@
     }
   });
 
-  var SubNodeCollectionControl =  Backform.SubNodeCollectionControl = Backform.Control.extend({
+  var SubNodeCollectionControl = Backform.SubNodeCollectionControl = Backform.Control.extend({
     render: function() {
       var field = _.defaults(this.field.toJSON(), this.defaults),
           attributes = this.model.toJSON(),
@@ -1258,14 +1259,14 @@
 
       if (!collection) {
         collection = new (pgBrowser.Node.Collection)(null, {
-          handler: self.model.handler || self,
+          handler: self.model.handler || self.model,
           model: data.model, top: self.model.top || self.model,
           silent: true
         });
         self.model.set(data.name, collection, {silent: true});
       }
 
-      var cellEditing = function(args){
+      var cellEditing = function(args) {
         var self = this,
           cell = args[0];
         // Search for any other rows which are open.
@@ -1369,20 +1370,18 @@
       this.dialog = o.dialog;
       this.tabIndex = o.tabIndex;
 
-      /*
-       * We will listen to the tab change event to check, if the SQL tab has
-       * been clicked or, not.
-       */
-      this.model.on('pg-property-tab-changed', this.onTabChange, this);
+      _.bindAll(this, 'onTabChange');
     },
     getValueFromDOM: function() {
         return this.formatter.toRaw(this.$el.find("textarea").val(), this.model);
     },
     render: function() {
       if (this.sqlCtrl) {
+        this.sqlCtrl.toTextArea();
         delete this.sqlCtrl;
         this.sqlCtrl = null;
         this.$el.empty();
+        this.model.off('pg-property-tab-changed', this.onTabChange, this);
       }
       // Use the Backform Control's render function
       Backform.Control.prototype.render.apply(this, arguments);
@@ -1397,6 +1396,12 @@
         tabSize: pgAdmin.Browser.editor_options.tabSize
       });
 
+      /*
+       * We will listen to the tab change event to check, if the SQL tab has
+       * been clicked or, not.
+       */
+      this.model.on('pg-property-tab-changed', this.onTabChange, this);
+
       return this;
     },
     onTabChange: function(obj) {
@@ -1447,8 +1452,10 @@
     },
     remove: function() {
       if (this.sqlCtrl) {
+        this.sqlCtrl.toTextArea();
         delete this.sqlCtrl;
         this.sqlCtrl = null;
+
         this.$el.empty();
       }
       this.model.off('pg-property-tab-changed', this.onTabChange, this);
@@ -1838,8 +1845,10 @@
       '   <option ',
       '    <% if (option.image) { %> data-image=<%=option.image%> <%}%>',
       '    value=<%= formatter.fromRaw(option.value) %>',
+      '    <% if (option.selected) {%>selected="selected"<%} else {%>',
       '    <% if (!select2.multiple && option.value === rawValue) {%>selected="selected"<%}%>',
       '    <% if (select2.multiple && rawValue && rawValue.indexOf(option.value) != -1){%>selected="selected" data-index="rawValue.indexOf(option.value)"<%}%>',
+      '    <%}%>',
       '    <%= disabled ? "disabled" : ""%>><%-option.label%></option>',
       '  <%}%>',
       ' </select>',
@@ -1920,7 +1929,9 @@
       if (this.$sel) {
         this.$sel.data('select2').on("keypress", function(ev) {
           var self = this;
-          if (ev.which === 9) { // keycode 9 is for TAB key
+
+          // keycode 9 is for TAB key
+          if (ev.which === 9 && self.isOpen()) {
             ev.preventDefault();
             self.trigger('results:select', {});
           }
@@ -2082,13 +2093,7 @@
       Backform.TextareaControl.prototype.initialize.apply(this, arguments);
       this.sqlCtrl = null;
 
-      // There is an issue with the Code Mirror SQL.
-      //
-      // It does not initialize the code mirror object completely when the
-      // referenced textarea is hidden (not visible), hence - we need to
-      // refresh the code mirror object on 'pg-property-tab-changed' event to
-      // make it work properly.
-      this.listenTo(this.model, 'pg-property-tab-changed', this.refreshTextArea);
+      _.bindAll(this, 'onFocus', 'onBlur', 'refreshTextArea');
     },
 
     getValueFromDOM: function() {
@@ -2098,6 +2103,11 @@
     render: function() {
       // Clean up the existing sql control
       if (this.sqlCtrl) {
+        this.model.off('pg-property-tab-changed', this.refreshTextArea, this);
+        this.sqlCtrl.off('focus', this.onFocus);
+        this.sqlCtrl.off('blur', this.onBlur);
+
+        this.sqlCtrl.toTextArea();
         delete this.sqlCtrl;
         this.sqlCtrl = null;
         this.$el.empty();
@@ -2147,6 +2157,17 @@
       if (!isVisible)
         self.$el.addClass(Backform.hiddenClassname);
 
+      // There is an issue with the Code Mirror SQL.
+      //
+      // It does not initialize the code mirror object completely when the
+      // referenced textarea is hidden (not visible), hence - we need to
+      // refresh the code mirror object on 'pg-property-tab-changed' event to
+      // make it work properly.
+      self.model.on('pg-property-tab-changed', this.refreshTextArea, this);
+
+      this.sqlCtrl.on('focus', this.onFocus);
+      this.sqlCtrl.on('blur', this.onBlur);
+
       var self = this;
       // Refresh SQL Field to refresh the control lazily after it renders
       setTimeout(function() {
@@ -2156,6 +2177,16 @@
       return self;
     },
 
+    onFocus: function() {
+      var $ctrl = this.$el.find('.pgadmin-controls').first();
+      if (!$ctrl.hasClass('focused'))
+        $ctrl.addClass('focused');
+    },
+
+    onBlur: function() {
+      this.$el.find('.pgadmin-controls').first().removeClass('focused');
+    },
+
     refreshTextArea: function() {
       if (this.sqlCtrl) {
         this.sqlCtrl.refresh();
@@ -2165,12 +2196,14 @@
     remove: function() {
       // Clean up the sql control
       if (this.sqlCtrl) {
+        this.sqlCtrl.off('focus', this.onFocus);
+        this.sqlCtrl.off('blur', this.onBlur);
         delete this.sqlCtrl;
         this.sqlCtrl = null;
         this.$el.empty();
       }
 
-      this.stopListening(this.model, "pg-property-tab-changed", this.refreshTextArea);
+      this.model.off("pg-property-tab-changed", this.refreshTextArea, this);
 
       Backform.TextareaControl.prototype.remove.apply(this, arguments);
     }
@@ -2261,5 +2294,134 @@
     }
   });
 
+  var DatetimepickerControl = Backform.DatetimepickerControl =
+      Backform.InputControl.extend({
+    defaults: {
+      type: "text",
+      label: "",
+      options: {
+        format: "MMM D YYYY HH:mm:ss.SSS Z",
+        showClear: true,
+        showTodayButton: true,
+        toolbarPlacement: 'top'
+      },
+      placeholder: "MMM D YYYY HH:mm:ss.SSS Z",
+      extraClasses: [],
+      helpMessage: null
+    },
+    events: {
+      "blur input": "onChange",
+      "change input": "onChange",
+      "changeDate input": "onChange",
+      "focus input": "clearInvalid",
+      'db.change': "onChange",
+      'click': 'openPicker'
+    },
+    openPicker: function() {
+      if (this.has_datepicker) {
+        this.$el.find("input").datetimepicker('show');
+      }
+    },
+    template: _.template([
+      '<label class="<%=Backform.controlLabelClassName%>"><%=label%></label>',
+      '<div class="input-group  <%=Backform.controlsClassName%>">',
+      ' <input type="text" class="<%=Backform.controlClassName%> <%=extraClasses.join(\' \')%>" name="<%=name%>" value="<%-value%>" placeholder="<%-placeholder%>" <%=disabled ? "disabled" : ""%> <%=required ? "required" : ""%> />',
+      ' <span class="input-group-addon">',
+      '  <span class="fa fa-calendar"></span>',
+      ' </span>',
+      ' <% if (helpMessage && helpMessage.length) { %>',
+      '  <span class="<%=Backform.helpMessageClassName%>"><%=helpMessage%></span>',
+      ' <% } %>',
+      '</div>'
+    ].join("\n")),
+    render: function() {
+      var field = _.defaults(this.field.toJSON(), this.defaults),
+          attributes = this.model.toJSON(),
+          attrArr = field.name.split('.'),
+          name = attrArr.shift(),
+          path = attrArr.join('.'),
+          rawValue = this.keyPathAccessor(attributes[name], path),
+          data = _.extend(field, {
+            rawValue: rawValue,
+            value: this.formatter.fromRaw(rawValue, this.model),
+            attributes: attributes,
+            formatter: this.formatter
+          }),
+          evalF = function(f, m) {
+            return (_.isFunction(f) ? !!f(m) : !!f);
+          };
+
+      // Evaluate the disabled, visible, and required option
+      _.extend(data, {
+        disabled: evalF(data.disabled, this.model),
+        visible:  evalF(data.visible, this.model),
+        required: evalF(data.required, this.model)
+      });
+      if (!data.disabled) {
+        data.placeholder = data.placeholder || this.defaults.placeholder;
+      }
+
+      // Clean up first
+      if (this.has_datepicker)
+        this.$el.find("input").datetimepicker('destroy');
+      this.$el.empty();
+      this.$el.removeClass(Backform.hiddenClassname);
+
+
+      this.$el.html(this.template(data)).addClass(field.name);
+
+      if (!data.visible) {
+        this.has_datepicker = false;
+        this.$el.addClass(Backform.hiddenClassname);
+      } else {
+        this.has_datepicker = true;
+        var self = this;
+        this.$el.find("input").first().datetimepicker(
+          _.extend({
+            keyBinds: {
+              enter: function(widget) {
+                var picker = this;
+                if (widget) {
+                  setTimeout(function() {
+                    picker.toggle();
+                    self.$el.find('input').first().blur();
+                  }, 10);
+                } else {
+                  setTimeout(function() { picker.toggle(); }, 10);
+                }
+              },
+              tab: function(widget) {
+                if (!widget) {
+                  // blur the input
+                  setTimeout(
+                    function() { self.$el.find('input').first().blur(); }, 10
+                  );
+                }
+              },
+              escape: function(widget) {
+                if (widget) {
+                  var picker = this;
+                  setTimeout(function() {
+                    picker.toggle();
+                    self.$el.find('input').first().blur();
+                  }, 10);
+                }
+              }
+            }
+          }, this.defaults.options, this.field.get("options"),
+          {'date': data.value})
+        );
+      }
+      this.updateInvalid();
+
+      return this;
+    },
+    cleanup: function() {
+      if (this.has_datepicker)
+        this.$el.find("input").datetimepicker('destroy');
+      this.$el.empty();
+    }
+  });
+
   return Backform;
 }));
diff --git a/web/pgadmin/static/js/backgrid/backgrid.pgadmin.js b/web/pgadmin/static/js/backgrid/backgrid.pgadmin.js
index 86a260a..af58c06 100644
--- a/web/pgadmin/static/js/backgrid/backgrid.pgadmin.js
+++ b/web/pgadmin/static/js/backgrid/backgrid.pgadmin.js
@@ -1,11 +1,11 @@
 (function(root, factory) {
   // Set up Backform appropriately for the environment. Start with AMD.
   if (typeof define === 'function' && define.amd) {
-    define(['underscore', 'jquery', 'backbone', 'backform', 'backgrid', 'alertify'],
-     function(_, $, Backbone, Backform, Backgrid, Alertify) {
+    define(['underscore', 'jquery', 'backbone', 'backform', 'backgrid', 'alertify', 'moment'],
+     function(_, $, Backbone, Backform, Backgrid, Alertify, moment) {
       // Export global even in AMD case in case this script is loaded with
       // others that may still expect a global Backform.
-      return factory(root, _, $, Backbone, Backform, Alertify);
+      return factory(root, _, $, Backbone, Backform, Alertify, moment);
     });
 
   // Next for Node.js or CommonJS. jQuery may not be needed as a module.
@@ -15,13 +15,14 @@
       Backbone = require('backbone') || root.Backbone,
       Backform = require('backform') || root.Backform;
       Alertify = require('alertify') || root.Alertify;
-    factory(root, _, $, Backbone, Backform, Alertify);
+      moment = require('moment') || root.moment;
+    factory(root, _, $, Backbone, Backform, Alertify, moment);
 
   // Finally, as a browser global.
   } else {
     factory(root, root._, (root.jQuery || root.Zepto || root.ender || root.$), root.Backbone, root.Backform);
   }
-} (this, function(root, _, $, Backbone, Backform, Alertify) {
+} (this, function(root, _, $, Backbone, Backform, Alertify, moment) {
   /*
      * Add mechanism in backgrid to render different types of cells in
      * same column;
@@ -544,7 +545,9 @@
       if (this.$sel) {
         this.$sel.data('select2').on("keypress", function(ev) {
           var self = this;
-          if (ev.which === 9) { // keycode 9 is for TAB key
+
+          // keycode 9 is for TAB key
+          if (ev.which === 9 && self.isOpen()) {
             self.trigger('results:select', {});
             ev.preventDefault();
           }
@@ -970,6 +973,193 @@
         formatter: JSONBCellFormatter
       });
 
+  var DatepickerCell = Backgrid.Extension.DatepickerCell = Backgrid.Cell.extend({
+    editor: DatepickerCellEditor
+  });
+
+  var DatepickerCellEditor = Backgrid.InputCellEditor.extend({
+    events:{},
+    initialize:function() {
+      Backgrid.InputCellEditor.prototype.initialize.apply(this, arguments);
+      var input = this;
+      $(this.el).prop('readonly', true);
+      $(this.el).datepicker({
+        onClose: function(newValue){
+          var command = new Backgrid.Command({});
+          input.model.set(input.column.get("name"), newValue);
+          input.model.trigger(
+            "backgrid:edited", input.model, input.column, command
+          );
+          command = input = null;
+        }
+      });
+    }
+  });
+
+  // Reference:
+  // https://github.com/wyuenho/backgrid-moment-cell/blob/master/backgrid-moment-cell.js
+  /**
+   MomentFormatter converts bi-directionally any datetime values in any format
+   supported by [moment()](http://momentjs.com/docs/#/parsing/) to any
+   datetime format
+   [moment.fn.format()](http://momentjs.com/docs/#/displaying/format/)
+   supports.
+   @class Backgrid.Extension.MomentFormatter
+   @extends Backgrid.CellFormatter
+   @constructor
+   */
+  var MomentFormatter = Backgrid.Extension.MomentFormatter = function (options) {
+    _.extend(this, this.defaults, options);
+  };
+
+  MomentFormatter.prototype = new Backgrid.CellFormatter;
+  _.extend(MomentFormatter.prototype, {
+    /**
+       @cfg {Object} options
+       @cfg {boolean} [options.modelInUnixOffset=false] Whether the model values
+       should be read/written as the number of milliseconds since UNIX Epoch.
+       @cfg {boolean} [options.modelInUnixTimestamp=false] Whether the model
+       values should be read/written as the number of seconds since UNIX Epoch.
+       @cfg {boolean} [options.modelInUTC=true] Whether the model values should
+       be read/written in UTC mode or local mode.
+       @cfg {string} [options.modelLang=moment.locale() moment>=2.8.0 |
+       moment.lang() moment<2.8.0] The locale the model values should be
+       read/written in.
+       @cfg {string} [options.modelFormat=moment.defaultFormat] The format this
+       moment formatter should use to read/write model values. Only meaningful if
+       the values are strings.
+       @cfg {boolean} [options.displayInUnixOffset=false] Whether the display
+       values should be read/written as the number of milliseconds since UNIX
+       Epoch.
+       @cfg {boolean} [options.displayInUnixTimestamp=false] Whether the display
+       values should be read/written as the number of seconds since UNIX Epoch.
+       @cfg {boolean} [options.displayInUTC=true] Whether the display values
+       should be read/written in UTC mode or local mode.
+       @cfg {string} [options.displayLang=moment.locale() moment>=2.8.0 |
+       moment.lang() moment<2.8.0] The locale the display values should be
+       read/written in.
+       @cfg {string} [options.displayFormat=moment.defaultFormat] The format
+       this moment formatter should use to read/write dislay values.
+       */
+    defaults: {
+      modelInUnixOffset: false,
+      modelInUnixTimestamp: false,
+      modelInUTC: true,
+      modelLang: moment.locale(),
+      modelFormat: moment.defaultFormat,
+      displayInUnixOffset: false,
+      displayInUnixTimestamp: false,
+      displayInUTC: true,
+      displayLang: moment.locale(),
+      displayFormat: moment.defaultFormat,
+      allowEmpty: false
+    },
+
+    /**
+       Converts datetime values from the model for display.
+       @member Backgrid.Extension.MomentFormatter
+       @param {*} rawData
+       @return {string}
+       */
+    fromRaw: function (rawData) {
+      if (rawData == null) return '';
+
+      var m = this.modelInUnixOffset ? moment(rawData) :
+        this.modelInUnixTimestamp ? moment.unix(rawData) :
+        this.modelInUTC ?
+        moment.utc(rawData, this.modelFormat, this.modelLang) :
+        moment(rawData, this.modelFormat, this.modelLang);
+
+      if (this.displayInUnixOffset) return +m;
+
+      if (this.displayInUnixTimestamp) return m.unix();
+
+      if (this.displayLang) m.locale(this.displayLang);
+
+      if (this.displayInUTC) m.utc(); else m.local();
+
+      if (this.displayFormat != moment.defaultFormat) {
+        return m.format(this.displayFormat);
+      }
+
+      return m.format();
+    },
+
+    /**
+       Converts datetime values from user input to model values.
+       @member Backgrid.Extension.MomentFormatter
+       @param {string} formattedData
+       @return {string}
+       */
+    toRaw: function (formattedData) {
+
+      var m = this.displayInUnixOffset ? moment(+formattedData) :
+        this.displayInUnixTimestamp ? moment.unix(+formattedData) :
+        this.displayInUTC ?
+        moment.utc(formattedData, this.displayFormat, this.displayLang) :
+        moment(formattedData, this.displayFormat, this.displayLang);
+
+      if (!m || !m.isValid()) return (this.allowEmpty && formattedData === '') ? null : undefined;
+
+      if (this.modelInUnixOffset) return +m;
+
+      if (this.modelInUnixTimestamp) return m.unix();
+
+      if (this.modelLang) m.locale(this.modelLang);
+
+      if (this.modelInUTC) m.utc(); else m.local()
+
+      if (this.modelFormat != moment.defaultFormat) {
+        return m.format(this.modelFormat);
+      }
+
+      return m.format();
+    }
+  });
+
+  var MomentCell = Backgrid.Extension.MomentCell = Backgrid.Cell.extend({
+
+    editor: Backgrid.InputCellEditor,
+
+    /** @property */
+    className: "datetime-cell",
+
+    /** @property {Backgrid.CellFormatter} [formatter=Backgrid.Extension.MomentFormatter] */
+    formatter: MomentFormatter,
+
+    /**
+       Initializer. Accept Backgrid.Extension.MomentFormatter.options and
+       Backgrid.Cell.initialize required parameters.
+     */
+    initialize: function (options) {
+
+      MomentCell.__super__.initialize.apply(this, arguments);
+
+      var formatterDefaults = MomentFormatter.prototype.defaults;
+      var formatterDefaultKeys = _.keys(formatterDefaults);
+      var classAttrs = _.pick(this, formatterDefaultKeys);
+      var formatterOptions = _.pick(options, formatterDefaultKeys);
+      var columnsAttrs = _.pick(this.column.toJSON(), formatterDefaultKeys);
+
+      // Priority of the options for the formatter, from highest to lowerest
+      // 1. MomentCell instance options
+      // 2. MomentCell class attributes
+      // 3. MomentFormatter defaults
+
+      // this.formatter will have been instantiated now
+      _.extend(this.formatter, formatterDefaults, classAttrs, formatterOptions, columnsAttrs);
+
+      this.editor = this.editor.extend({
+        attributes: _.extend({}, this.editor.prototype.attributes || this.editor.attributes || {}, {
+          placeholder: this.formatter.displayFormat
+        }),
+        options: this.column.get('options')
+      });
+    }
+  });
+
+  _.extend(MomentCell.prototype, MomentFormatter.prototype.defaults);
+
   return Backgrid;
 
 }));
